-- Useful table functions

function getnextoption(var, list)
  local i, j
  if next(list)~=nil then
    j = 0
    for i = 1, #list, 1 do
      if var==list[i] then
        j = i+1
        if j>#list then j = 1 end
      end
    end
    if j~=0 and list[j]~=nil then return list[j]
    else return list[1] end
  else return var end
end

function deepcopy(orig)
  local orig_type = type(orig)
  local copy
  if orig_type == 'table' then
    copy = {}
    for orig_key, orig_value in next, orig, nil do
      copy[deepcopy(orig_key)] = deepcopy(orig_value)
    end
    setmetatable(copy, deepcopy(getmetatable(orig)))
  else copy = orig end -- number, string, boolean, etc
  return copy
end